% Bacteria biofilm simulation - Jacobian sparsity matrix calculation
% Published in BMC Systems Biology
% Written by Poonam Phalak, Jin Chen and Michael A. Henson
% December, 2015

function Jac = jac_pa_biofilm(N,ns)

Jac(1:ns,:) = [ones(ns,2*ns) zeros(ns,(N-1)*ns)];
for i=2:N
    Jac((i-1)*ns+1:(i-1)*ns+ns,:) = [zeros(ns,(i-2)*ns) ones(ns,3*ns) zeros(ns,(N-i)*ns)];
end
Jac(N*ns+1:N*ns+ns,:) = [zeros(ns,(N-1)*ns) ones(ns,2*ns)];

Jac = [Jac; zeros(1,size(Jac,2))];
Jac = [Jac zeros(size(Jac,1),1)];